<template>
  <v-app>
    <v-app-bar
      app
      color="custom-peach"
      dark
    >
      <v-spacer></v-spacer>
      <div class="user-info-block lighter">
        <v-avatar>
          <img src="https://picsum.photos/seed/picsum/48"/>
        </v-avatar>
        <div class="user-header-bar">
          <p class="welcome">Jonas Doe</p>
          <p class="last-login">Último Login: {{ todayIs }}</p>
        </div>
        <div class="user-header-dropdown">
          <v-icon>
            mdi-menu-down
          </v-icon>
        </div>
      </div>
    </v-app-bar>

    <v-main>
      <UserList :users="users" v-on:added-user="addUser" :newuser="blank"/>
    </v-main>
  </v-app>
</template>

<script>
import UserList from '@/components/UserList.vue'


export default {
  name: 'App',

  components: {
    UserList
  },
  data: () => ({
    users: [],
    blank: {
        name: {
          first: '', 
          last: ''
        },
        dob: {
          age: ''
        },
        email: '',
        nat: 'BR',
        phone: '',
        picture: {
          thumbnail: 'https://dummyimage.com/48x48/#eee/fff.png'
        },
        registered: {
          date: '01/01/2001'
        },
        gender: 'male'
      },
  }),
  computed: {
    todayIs: function() { return this.moment().format('L'); }
  },
  created: function() {
    if (!localStorage.users) {
      this.getData()
    }
  },
  mounted() {
    if (localStorage.users) {
      this.users = JSON.parse(localStorage.users)
    }
  },
  methods: {
    getData() {
      fetch('https://randomuser.me/api/?results=10')
      .then(response => response.json())
      .then(userJson => { this.users = userJson.results; })
    },
    addUser(data) {
      const objectClone = JSON.parse(JSON.stringify(data));
      this.users.push(objectClone)
    },
  },
  watch: {
    users(currentUsers) {
      localStorage.users = JSON.stringify(currentUsers)
    }
  }
};
</script>

<style>
  .v-app-bar .v-avatar {
    margin-right: 1rem;
    border: 1px solid white;
  }

  .user-header-bar p {
    margin-bottom: 0;
  }

  .last-login {
    font-size: .75rem;
    font-weight: 300;
  }

  .user-info-block {
    display: flex;
    align-items: center;
  }

  .custom-peach {
    background-color: #ff6450 !important;
  }

  .header-link {
    font-size: .5rem;
  }

  .lighter {
    background-color: #fe7563;
  }

  @media (min-width: 768px) {
    .user-info-block {
      height: 100%;
      padding-left: 2rem;
      box-shadow: 0px -1px 24px 8px rgb(0 0 0 / 12%);
      margin-right: 10rem;
    }

    .user-header-dropdown {
      border-left: 2px solid rgba(97,97,97,.1);
      height: 100%;
      padding-left: 1.5rem;
      padding-right: 1.5rem;
      display: flex;
    }

    .user-header-bar {
      padding-right: 5rem;
    }

    .v-toolbar__content {
      padding: 0 !important;
    }
  }

</style>
